'use strict';
var yeoman = require('yeoman-generator');
var chalk = require('chalk');
var yosay = require('yosay');

module.exports = yeoman.Base.extend({
  prompting: function () {
    // Have Yeoman greet the user.
    this.log(yosay(
      'Welcome to the great ' + chalk.red('generator-at-typescript') + ' generator!'
    ));

    var prompts = [{
      name: 'someAnswer',
      message: 'What is the name of the app'
    }];

    return this.prompt(prompts).then(function (props) {
      // To access props later use this.props.someAnswer;
      this.props = props;
    }.bind(this));
  },

  scaffoldFolder: function(){
    this.mkdir('app');
    this.mkdir('app/dist');
    this.mkdir('app/dist/css');
    this.mkdir('app/dist/imges');
    this.mkdir('app/dist/imges/svg');
    this.mkdir('app/dist/js');
    this.mkdir('app/images');
    this.mkdir('app/images/svg');
    this.mkdir('app/scss');
    this.mkdir('app/ts');
    this.mkdir('app/typings');
  },
  
  copyMainFiles: function(){
    this.copy('_gruntfile.js', 'gruntfile.js');
    this.copy('_package.json', 'package.json');
    this.copy('_bower.json', 'bower.json');
    this.copy('_tsconfig.json', 'tsconfig.json');
    this.copy('_webpack.config.js', 'webpack.config.js');
    //
    this.copy('_main.scss', 'app/scss/main.scss');
    this.copy('_app.ts', 'app/ts/app.ts');
    this.copy('_index.html', 'app/index.html');
    var context = {
      site_name: this.appName
    };
    
  },

  writing: function () {
    this.fs.copy(
      this.templatePath('dummyfile.txt'),
      this.destinationPath('dummyfile.txt')
    );
  },

  install: function () {
    this.installDependencies();
  }
});
